<template>
  <div>
    <el-card class="el-card">
      <el-form :inline="true" :model="query" class="query-form" size="mini">
        <el-row>
          <el-form-item class="query-form-item" label="关键字搜索:">
            <el-input v-model="query.key" placeholder="参数关键字搜索" clearable></el-input>
          </el-form-item>
          <el-form-item>
            <el-button-group>
              <el-button icon="el-icon-refresh" type="primary" @click="onReset">重置</el-button>
              <el-button type="primary"
                         @click.native="search"
                         icon="el-icon-search">
                查询
              </el-button>
            </el-button-group>
          </el-form-item>
        </el-row>
      </el-form>
      <el-table v-loading="loading" :data="list" style="width: 100%" border>
        <el-table-column type="index" label="序号" width="50"></el-table-column>
        <el-table-column label="参数名" prop="paramName"></el-table-column>
        <el-table-column label="参数键" prop="paramKey" width="200"></el-table-column>
        <el-table-column label="参数值" prop="paramValue" width="100"></el-table-column>
        <el-table-column label="参数说明" :show-overflow-tooltip="true">
          <template slot-scope="scope">
            <span>{{ scope.row.paramExplain }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="100">
          <template slot-scope="scope">
            <el-button
              type="text"
              size="small"
              @click.native="handleForm(scope.$index, scope.row)"
            >设置
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="query.page"
        :limit.sync="query.limit"
        @pagination="getList"
      />

      <!--表单-->
      <el-dialog
        :title="formMap[formName]"
        :visible.sync="formVisible"
        :close-on-click-modal="false"
        :close-on-press-escape="false"
        :before-close="hideForm"
        width="45%"
        top="5vh"
      >
        <el-form :model="formData" :rules="formRules" ref="dataForm">
          <el-row>
            <el-form-item label="参数名:" prop="paramName" label-width="100px">
              <el-input
                v-model="formData.paramName"
                auto-complete="off"
                :disabled="true"
                style="width: 90%"
              ></el-input>
            </el-form-item>

          </el-row>

          <el-row>
            <el-form-item label="参数键:" prop="paramKey" label-width="100px">
              <el-input
                v-model="formData.paramKey"
                auto-complete="off" style="width: 90%"
                :disabled="true"
              ></el-input>
            </el-form-item>
          </el-row>
          <el-row>
            <el-form-item label="参数值" prop="paramValue" label-width="100px">
              <el-input type="" v-model="formData.paramValue" auto-complete="off" style="width: 90%"></el-input>
            </el-form-item>
          </el-row>
          <el-row>
            <el-form-item label="参数说明:" label-width="100px">
              <el-input
                type="textarea"
                v-model="formData.paramExplain" style="width: 90%"
                :disabled="true"
              ></el-input>
            </el-form-item>
          </el-row>

          <!--<el-form-item label="参数状态" prop="paramStatus">-->
          <!--<el-radio-group v-model="formData.paramStatus">-->
          <!--<el-radio :label="0">禁用</el-radio>-->
          <!--<el-radio :label="1">正常</el-radio>-->
          <!--</el-radio-group>-->
          <!--</el-form-item>-->

        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click.native="hideForm">取消</el-button>
          <el-button type="primary" @click.native="formSubmit()" :loading="formLoading"
          >提交
          </el-button>
        </div>
      </el-dialog>
    </el-card>
  </div>
</template>

<script>
import {
  systemParamConfigList,
  systemParamConfigSave,
} from "@/api/system/param/systemParamConfig";

const formJson = {
  id: "",
  parentId: "",
  paramName: "",
  paramKey: "",
  paramValue: "",
  paramStatus: 1,
  paramType: 1,
  paramExplain: "",
};
export default {
  data() {
    return {
      query: {
        key: null,
        paramStatus: 1,
        page: 1,
        paramType: 0,
        limit: 20,
      },
      list: [],
      total: 0,
      loading: true,
      index: null,
      formName: null,
      formMap: {
        add: "新增运行参数",
        update: "运行参数设置",
      },
      formLoading: false,
      formVisible: false,
      formData: formJson,
      formRules: {
        paramValue: [{required: true, message: "请输入参数值", trigger: "blur"}],
        // ,
        // paramStatus: [
        //     {required: true, message: "请选择参数状态", trigger: "change"}
        // ]
      },
      deleteLoading: false,
      filterQuery: {}
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.query = {
        paramStatus: 1,
        page: 1,
        limit: 20,
      };
      this.getList();
    },
    onSubmit() {
      this.getList();
    },
    handleCurrentChange(val) {
      this.query.page = val;
      this.getList();
    },
    search() {
      this.query.page = 1;
      this.getList();
    },
    getList() {
      this.loading = true;
      systemParamConfigList(this.query)
        .then((response) => {
          this.loading = false;
          this.list = response.data.list || [];
          this.total = response.data.total || 0;
        })
        .catch(() => {
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    // 刷新表单
    resetForm() {
      if (this.$refs["dataForm"]) {
        // 清空验证信息表单
        this.$refs["dataForm"].clearValidate();
        // 刷新表单
        this.$refs["dataForm"].resetFields();
        this.getList();
      }
    },
    // 隐藏表单
    hideForm() {
      // 更改值
      this.formVisible = !this.formVisible;
      return true;
    },
    // 显示表单
    handleForm(index, row) {
      this.formVisible = true;
      this.formData = JSON.parse(JSON.stringify(formJson));
      if (row !== null) {
        this.formData = Object.assign({}, row);
      }
      this.formName = "add";
      if (index !== null) {
        this.index = index;
        this.formName = "update";
      }
    },
    formSubmit() {
      // if (!Number.isInteger(parseInt(this.formData.paramValue))) {
      //     this.$message.warning("参数值必须为数字");
      //     return;
      // }
      this.$refs["dataForm"].validate((valid) => {
        if (valid) {
          this.formLoading = true;
          let data = Object.assign({}, this.formData);
          data.paramValue = data.paramValue.trim();
          systemParamConfigSave(data, this.formName)
            .then((response) => {
              this.formLoading = false;
              if (response.code != 20000) {
                this.$message.error(response.message);
                return false;
              }
              this.$message.success("操作成功");
              this.formVisible = false;
              if (this.formName === "add") {
                // 向头部添加数据
                if (response.data && response.data.id) {
                  data.id = response.data.id;
                  this.list.unshift(data);
                }
              } else {
                this.list.splice(this.index, 1, data);
              }
              // 刷新表单
              this.resetForm();
              this.getList();
            })
            .catch(() => {
              this.formLoading = false;
            });
        }
      });
    },
  },
  filters: {
    paramStatusFilterType(paramStatus) {
      const paramStatusMap = {
        0: "gray",
        1: "success",
      };
      return paramStatusMap[paramStatus];
    },
    paramStatusFilterName(paramStatus) {
      const paramStatusMap = {
        0: "禁用",
        1: "正常",
      };
      return paramStatusMap[paramStatus];
    },
  },
  mounted() {
  },
  created() {
    // 加载表格数据
    this.getList();
  },
};
</script>

